# -*- coding: Shift-JIS -*-
import clr
import CommandPlugin
from CommandPlugin import WinAPI

class WinRect(object):
  """ OEBhËړTCY̕ύXȒPɍs
  
  gpF
  # hwndɊOEBhẼEBhEnh擾Ăꍇ
  win_rect = WinRect(hwnd)
  win_rect.left = 100  # EBhE̍[̍W100ɂ
  win_rect.right = 500 # EBhẺE[̍W500ɂ
  win_rect.width = 300 # EBhE̕300ɂ
  """

  def __init__(self, hwnd):
    self.hwnd = hwnd

  def get_rect(self):
    """ EBhËʒuƃTCY擾 """
    return WinAPI.GetWindowRect(self.hwnd)

  def set_left(self, value):
    rect = self.get_rect()
    WinAPI.MoveWindow(self.hwnd, value, rect.Top, rect.Width, rect.Height)

  def set_right(self, value):
    rect = self.get_rect()
    left = value - rect.Width
    WinAPI.MoveWindow(self.hwnd, left, rect.Top, rect.Width, rect.Height)
  
  def set_top(self, value):
    rect = self.get_rect()
    WinAPI.MoveWindow(self.hwnd, rect.Left, value, rect.Width, rect.Height)

  def set_bottom(self, value):
    rect = self.get_rect()
    top = value - rect.Height
    WinAPI.MoveWindow(self.hwnd, rect.Left, top, rect.Width, rect.Height)

  def set_width(self, value):
    rect = self.get_rect()
    WinAPI.MoveWindow(self.hwnd, rect.Left, rect.Top, value, rect.Height)

  def set_height(self, value):
    rect = self.get_rect()
    WinAPI.MoveWindow(self.hwnd, rect.Left, rect.Top, rect.Width, value)
    
  rect = property(get_rect)
  top = property(lambda self: self.rect.Top, set_top)
  right = property(lambda self: self.rect.Right, set_right)
  bottom = property(lambda self: self.rect.Bottom, set_bottom)
  left = property(lambda self: self.rect.Left, set_left)
  width = property(lambda self: self.rect.Width, set_width)
  height = property(lambda self: self.rect.Height, set_height)

