# -*- coding: Shift-JIS -*-
import clr
import CommandPlugin
from CommandPlugin import *

clr.AddReferenceByPartialName("System")
from System import IntPtr
from lib.restore_window import RestoreWindow

class max_win(CommandPlugin.PythonCommand):
  def __init__(self):
    self.restore_win = RestoreWindow()

  def run(self, info, arg_list):
    # argumentŎw肵ftHg͖̈
    arg_list.RemoveAt(0)

    if len(arg_list) == 0:
      # Ȃꍇ͍őOʂ̃EBhEő剻
      if info.last_fore_window != IntPtr(0):
        hwnd = info.last_fore_window
        self.change_state(hwnd)
    else:
      # ꍇ̓qg̕ƈvEBhEő剻
      for arg in arg_list:
        index = info.hint_list.IndexOf(arg.ToUpper())
        if index != -1:
          win = info.window_list[index]
          self.change_state(win.hwnd)
          break
  
  def change_state(self, hwnd):
    if not WinAPI.IsZoomed(hwnd):
      self.restore_win.add(hwnd)
      WinAPI.MaximizeWindow(hwnd)
    else:
      WinAPI.RestoreWindow(hwnd)

  def undo(self):
    self.restore_win.restore()
    return True

