# -*- coding: Shift-JIS -*-
import clr
import CommandPlugin
from CommandPlugin import WinAPI

clr.AddReferenceByPartialName("System.Windows.Forms")
from System.Windows.Forms import Screen

from lib.restore_window import RestoreWindow

# 
# w肵EBhEɕׂTv
# 

class side_window(CommandPlugin.PythonCommand):
  def __init__(self):
    self.restore_win = RestoreWindow()

  def run(self, info, arg_list):
    # argumentŎw肵ftHg͖̈
    arg_list.RemoveAt(0)
    
    win_list = []
    if len(arg_list) == 1:
      index = info.hint_list.IndexOf(arg_list[0].ToUpper())
      if index != -1:
        win = info.window_list[index]
        win_list.append(win)
        self.restore_win.add(win.hwnd)
        WinAPI.MaximizeWindow(win.hwnd)
      return ""
  
    for arg in arg_list:
        index = info.hint_list.IndexOf(arg.ToUpper())
        if index != -1:
          win = info.window_list[index]
          win_list.append(win)
          self.restore_win.add(win.hwnd)
    
    working_width = Screen.GetWorkingArea(info.main_form).Width
    working_height = Screen.GetWorkingArea(info.main_form).Height
    width = working_width / len(win_list)
    height = working_height
    
    left = 0
    for win in win_list:
      WinAPI.WakeupWindow(win.hwnd)
      WinAPI.MoveWindow(win.hwnd, left, 0, width, height)
      left += width

    WinAPI.RedrawDesktop() 

  def undo(self):
    self.restore_win.restore()
    return True


