# -*- coding: Shift-JIS -*-
import clr
import CommandPlugin
from CommandPlugin import *

clr.AddReferenceByPartialName("System")
clr.AddReferenceByPartialName("System.Windows.Forms")
from System import IntPtr
from System.Windows.Forms import MessageBox
from System.Diagnostics import ProcessStartInfo, Process
from System.IO import Path

class exe_folder(CommandPlugin.PythonCommand):
  def run(self, info, arg_list):
    # argumentŎw肵tH_Jt@C擾
    filer = arg_list[0]
    arg_list.RemoveAt(0)

    if len(arg_list) == 0:
      # ͂Ȃꍇ͍őOʂ̃EBhẼtH_J
      if info.last_fore_window != IntPtr(0):
      	if not WinAPI.IsIconic(info.last_fore_window):
          win = info.GetTaskWindow(info.last_fore_window)
          self.open_folder(filer, win.exePath)
    else:
      # ͂ꍇ̓qg̕ƈvEBhẼtH_J
      for arg in arg_list:
        index = info.hint_list.IndexOf(arg.ToUpper())
        if index != -1:
          self.open_folder(filer, info.window_list[index].exePath)

  def open_folder(self, filer, path):
    directory = Path.GetDirectoryName(path)
    psi = ProcessStartInfo()
    if filer == "":
      psi.FileName = directory
    else:
      psi.FileName = filer
      psi.Arguments = directory
    psi.RedirectStandardInput = False
    psi.RedirectStandardOutput = False
    psi.UseShellExecute = True
    psi.CreateNoWindow = True
    Process.Start(psi)
    
