# -*- coding: Shift-JIS -*-
import clr
import CommandPlugin
from CommandPlugin import *

clr.AddReferenceByPartialName("System")
from System import IntPtr
clr.AddReferenceByPartialName("System.Windows.Forms")
from System.Windows.Forms import MessageBox

from lib.restore_window import RestoreWindow

class min_win(CommandPlugin.PythonCommand):
  def __init__(self):
    self.restore_win = RestoreWindow()

  def run(self, info, arg_list):
    # argumentŎw肵ftHg͖̈
    arg_list.RemoveAt(0)

    if len(arg_list) == 0:
      # Ȃꍇ͍őOʂ̃EBhEŏ
      hwnd = info.last_fore_window
      if hwnd != IntPtr(0):
      	if not WinAPI.IsIconic(hwnd):
          self.restore_win.add(hwnd)
       	  WinAPI.MinimizeWindow(hwnd)
    else:
      # ꍇ̓qg̕ƈvEBhEŏ
      for arg in arg_list:
        index = info.hint_list.IndexOf(arg.ToUpper())
        if index != -1:
          win = info.window_list[index]
          self.restore_win.add(win.hwnd)
          WinAPI.MinimizeWindow(win.hwnd)
  
  def undo(self):
    self.restore_win.restore()
    return True

